VST 3 Examples VST 3.7 SDK for developing VST plug-in

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Macros Groups Pages
Public Types | Public Member Functions | Static Public Member Functions | List of all members
PlugController Class Reference

`#include <plugcontroller.h>`

Inheritance diagram for PlugController:

## Public Types
using | CView = VSTGUI::CView
using | CTextEdit = VSTGUI::CTextEdit
using | UTF8StringPtr = VSTGUI::UTF8StringPtr
using | UIAttributes = VSTGUI::UIAttributes
using | IUIDescription = VSTGUI::IUIDescription
using | VST3Editor = VSTGUI::VST3Editor
using | CTextLabel = VSTGUI::CTextLabel
Public Types inherited from EditControllerEx1
typedef (EditControllerEx1, EditController) DEFINE_INTERFACES DEF_INTERFACE(IUnitInfo) END_DEFINE_INTERFACES(EditController) REFCOUNT_METHODS(EditController) protected std::map < ProgramListID, ProgramListVector::size_type > | ProgramIndexMap
typedef std::vector< IPtr< Unit >> | UnitVector

## Public Member Functions
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
tresult | setComponentState (IBStream *state) SMTG_OVERRIDE
tresult | setChannelContextInfos (IAttributeList *list) SMTG_OVERRIDE
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
tresult | setComponentState (IBStream *state) SMTG_OVERRIDE
IPlugView * | createView (const char *name) SMTG_OVERRIDE
CView * | createCustomView (UTF8StringPtr name, const UIAttributes &attributes, const IUIDescription *description, VST3Editor *editor) SMTG_OVERRIDE
void | willClose (VST3Editor *editor) SMTG_OVERRIDE
tresult | notify (IMessage *message) SMTG_OVERRIDE
tresult | receiveText (const char8 *text) SMTG_OVERRIDE
int32 | getNoteExpressionCount (int32 busIndex, int16 channel) SMTG_OVERRIDE
tresult | getNoteExpressionInfo (int32 busIndex, int16 channel, int32 noteExpressionIndex, NoteExpressionTypeInfo &info) SMTG_OVERRIDE
tresult | getNoteExpressionStringByValue (int32 busIndex, int16 channel, NoteExpressionTypeID id, NoteExpressionValue valueNormalized, String128 string) SMTG_OVERRIDE
tresult | getNoteExpressionValueByString (int32 busIndex, int16 channel, NoteExpressionTypeID id, const TChar *string, NoteExpressionValue &valueNormalized) SMTG_OVERRIDE
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
tresult | setComponentState (IBStream *state) SMTG_OVERRIDE
tresult | setParamNormalized (ParamID tag, ParamValue value) SMTG_OVERRIDE
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
tresult | setParamNormalized (ParamID tag, ParamValue value) SMTG_OVERRIDE
tresult | setComponentState (IBStream *state) SMTG_OVERRIDE
tresult | getUnitByBus (MediaType, BusDirection, int32, int32, UnitID &) SMTG_OVERRIDE
Public Member Functions inherited from EditControllerEx1
| EditControllerEx1 ()
| ~EditControllerEx1 () override
tresult | terminate () SMTG_OVERRIDE
bool | addUnit (Unit *unit)
bool | addProgramList (ProgramList *list)
ProgramList * | getProgramList (ProgramListID listId) const
tresult | notifyProgramListChange (ProgramListID listId, int32 programIndex=kAllProgramInvalid)
int32 | getUnitCount () SMTG_OVERRIDE
tresult | getUnitInfo (int32 unitIndex, UnitInfo &info) SMTG_OVERRIDE
int32 | getProgramListCount () SMTG_OVERRIDE
tresult | getProgramListInfo (int32 listIndex, ProgramListInfo &info) SMTG_OVERRIDE
tresult | getProgramName (ProgramListID listId, int32 programIndex, String128 name) SMTG_OVERRIDE
tresult | getProgramInfo (ProgramListID listId, int32 programIndex, CString attributeId, String128 attributeValue) SMTG_OVERRIDE
tresult | hasProgramPitchNames (ProgramListID listId, int32 programIndex) SMTG_OVERRIDE
tresult | getProgramPitchName (ProgramListID listId, int32 programIndex, int16 midiPitch, String128 name) SMTG_OVERRIDE
virtual tresult | setProgramName (ProgramListID listId, int32 programIndex, const String128 name)
UnitID | getSelectedUnit () SMTG_OVERRIDE
tresult | selectUnit (UnitID unitId) SMTG_OVERRIDE
tresult | setUnitProgramData (int32, int32, IBStream *) SMTG_OVERRIDE
virtual tresult | notifyUnitSelection ()
void | update (FUnknown *changedUnknown, int32 message) SMTG_OVERRIDE
Public Member Functions inherited from EditController
| EditController ()
tresult | setState (IBStream *state) SMTG_OVERRIDE
tresult | getState (IBStream *state) SMTG_OVERRIDE
int32 | getParameterCount () SMTG_OVERRIDE
tresult | getParameterInfo (int32 paramIndex, ParameterInfo &info) SMTG_OVERRIDE
tresult | getParamStringByValue (ParamID tag, ParamValue valueNormalized, String128 string) SMTG_OVERRIDE
tresult | getParamValueByString (ParamID tag, TChar *string, ParamValue &valueNormalized) SMTG_OVERRIDE
ParamValue | normalizedParamToPlain (ParamID tag, ParamValue valueNormalized) SMTG_OVERRIDE
ParamValue | plainParamToNormalized (ParamID tag, ParamValue plainValue) SMTG_OVERRIDE
ParamValue | getParamNormalized (ParamID tag) SMTG_OVERRIDE
tresult | setComponentHandler (IComponentHandler *handler) SMTG_OVERRIDE
IPlugView * | createView (FIDString) SMTG_OVERRIDE
tresult | setKnobMode (KnobMode mode) SMTG_OVERRIDE
tresult | openHelp (TBool) SMTG_OVERRIDE
tresult | openAboutBox (TBool) SMTG_OVERRIDE
virtual tresult | beginEdit (ParamID tag)
virtual tresult | performEdit (ParamID tag, ParamValue valueNormalized)
virtual tresult | endEdit (ParamID tag)
virtual tresult | startGroupEdit ()
virtual tresult | finishGroupEdit ()
virtual void | editorDestroyed (EditorView *)
virtual void | editorAttached (EditorView *)
virtual void | editorRemoved (EditorView *)
virtual Parameter * | getParameterObject (ParamID tag)
virtual tresult | getParameterInfoByTag (ParamID tag, ParameterInfo &info)
virtual tresult | setDirty (TBool state)
virtual tresult | requestOpenEditor (FIDString name=ViewType::kEditor)
IComponentHandler * | getComponentHandler () const

## Static Public Member Functions
static FUnknown * | createInstance (void *)
static FUnknown * | createInstance (void *)
static FUnknown * | createInstance (void *)
static FUnknown * | createInstance (void *)

## Additional Inherited Members
Public Attributes inherited from EditControllerEx1
UnitVector | units
ProgramListVector | programLists
ProgramIndexMap | programIndexMap
UnitID | selectedUnit
Static Public Attributes inherited from EditController
static KnobMode | hostKnobMode
Static Public Attributes inherited from IUnitInfo
static const FUID | iid
Static Public Attributes inherited from INoteExpressionController
static const FUID | iid
Static Public Attributes inherited from IInfoListener
static const FUID | iid

## Member Typedef Documentation

using CView = VSTGUI::CView

using CTextEdit = VSTGUI::CTextEdit

using UTF8StringPtr = VSTGUI::UTF8StringPtr

using UIAttributes = VSTGUI::UIAttributes

using IUIDescription = VSTGUI::IUIDescription

using VST3Editor = VSTGUI::VST3Editor

using CTextLabel = VSTGUI::CTextLabel

## Member Function Documentation

static FUnknown* createInstance | ( | void * |  | ) |
| inline static

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Reimplemented from EditController.

tresult setComponentState | ( | IBStream * | state | ) |
| virtual

Reimplemented from EditController.

tresult setChannelContextInfos | ( | IAttributeList * | list | ) |
| virtual

Implements IInfoListener.

static FUnknown* createInstance | ( | void * |  | ) |
| inline static

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Reimplemented from EditController.

tresult setComponentState | ( | IBStream * | state | ) |
| virtual

Reimplemented from EditController.

IPlugView * createView | ( | const char * | name | ) |

CView * createCustomView | ( | UTF8StringPtr | name,
|  | const UIAttributes & | attributes,
|  | const IUIDescription * | description,
|  | VST3Editor * | editor
| ) |  |

void willClose | ( | VST3Editor * | editor | ) |

tresult notify | ( | IMessage * | message | ) |
| virtual

Implements IConnectionPoint.

tresult receiveText | ( | const char8 * | text | ) |

int32 getNoteExpressionCount | ( | int32 | busIndex,
|  | int16 | channel
| ) |  |
| virtual

Implements INoteExpressionController.

tresult getNoteExpressionInfo | ( | int32 | busIndex,
|  | int16 | channel,
|  | int32 | noteExpressionIndex,
|  | NoteExpressionTypeInfo & | info
| ) |  |
| virtual

Implements INoteExpressionController.

tresult getNoteExpressionStringByValue | ( | int32 | busIndex,
|  | int16 | channel,
|  | NoteExpressionTypeID | id,
|  | NoteExpressionValue | valueNormalized,
|  | String128 | string
| ) |  |
| virtual

Implements INoteExpressionController.

tresult getNoteExpressionValueByString | ( | int32 | busIndex,
|  | int16 | channel,
|  | NoteExpressionTypeID | id,
|  | const TChar * | string,
|  | NoteExpressionValue & | valueNormalized
| ) |  |
| virtual

Implements INoteExpressionController.

static FUnknown* createInstance | ( | void * |  | ) |
| inline static

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Reimplemented from EditController.

tresult setComponentState | ( | IBStream * | state | ) |
| virtual

Reimplemented from EditController.

tresult setParamNormalized | ( | ParamID | tag,
|  | ParamValue | value
| ) |  |
| virtual

Reimplemented from EditController.

static FUnknown* createInstance | ( | void * |  | ) |
| inline static

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Reimplemented from EditController.

tresult setParamNormalized | ( | ParamID | tag,
|  | ParamValue | value
| ) |  |
| virtual

Reimplemented from EditController.

tresult setComponentState | ( | IBStream * | state | ) |
| virtual

Reimplemented from EditController.

tresult getUnitByBus | ( | MediaType | type,
|  | BusDirection | dir,
|  | int32 | busIndex,
|  | int32 | channel,
|  | UnitID & | unitId
| ) |  |
| virtual

Reimplemented from EditControllerEx1.

Empty

Copyright ©2024 Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.